/////////////////////////////////////////////////////////////////////////
 //                 LLIBRERIES DE L’ESP8266                  //
/////////////////////////////////////////////////////////////////////////

#include <ESP8266WiFi.h>

  /////////////////////////////////////////////////////////////////////////
 //             PARÀMETRES DEL WIFI I DEL SERVIDOR           //
/////////////////////////////////////////////////////////////////////////

// Servidor ThingSpeak
String apiKey = "74YPULIPVKTJTQAU";
const char* server = "api.thingspeak.com";

// SSID WiFi
const char* ssid = "Orange";
const char* password = "A5E1D37D3C";

// Declaració pin GPIO 0 connectat a CH_PD
int pinON = 0;

// Inicialització llibreria  
WiFiClient client;


  /////////////////////////////////////////////////////////////////////////
 //                    CONFIGURACIONS INICIALS               //
/////////////////////////////////////////////////////////////////////////

void setup() {

    // Cada vegada que es desperta, es reinicia, i el pinON activa CH_PD 
  pinMode(pinON, OUTPUT);
  digitalWrite(pinON, HIGH);
  delayMicroseconds(100);

  // Inici comunicació serie amb l’Arduino
  Serial.begin(115200);

  // Connexió a la xarxa
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
      delayMicroseconds(100);
  }
}

  /////////////////////////////////////////////////////////////////////////
 //                        BUCLE PRINCIPAL                       //
/////////////////////////////////////////////////////////////////////////

void loop() {

     // Connexió al servidor 
  String bufferArray[ 4 ];
  if (client.connect(server, 80)) { 
    String postStr = apiKey;

    // Emmagatzament dades del port serie
    if ( Serial.available() > 1) {
      for (int i = 0; i < 3; i++) {     
          bufferArray[ i ] = Serial.readStringUntil('\n');
      }

    // Descodificació primer caràcter de la primera dada
      String BatS = bufferArray[0];
      if (BatS.charAt(0) == 'B') {
          BatS.remove(0, 1);

       // Guardar al camp que relaciona amb al servidor
          postStr += "&field1=";
          postStr += String(BatS);
      }

      // Descodificació i guardar al camp
      String SolS = bufferArray[1];
      if (SolS.charAt(0) == 'S') {
          SolS.remove(0, 1);
          postStr += "&field2=";
          postStr += String(SolS);
      }
      String BatC = bufferArray[2];
      if (BatC .charAt(0) == 'C') {
          BatC .remove(0, 1);
          postStr += "&field3=";
          postStr += String(BatC );
      }
      String SolC = bufferArray[2];
      if (SolC.charAt(0) == 'T') {
          SolC.remove(0, 1);
          postStr += "&field4=";
          postStr += String(SolC);
      }
      String Acc = bufferArray[2];
      if (Acc.charAt(0) == 'A') {
          Acc.remove(0, 1);
          postStr += "&field5=";
          postStr += String(Acc);
      }
      String Id = bufferArray[2];
      if (Id.charAt(0) == 'I') {
          Id.remove(0, 1);
          postStr += "&field6=";
          postStr += String(Id);
      }
    }

    // Enviament de les dades al servidor 
    postStr += "\r\n\r\n";
    client.print("POST /update HTTP/1.1\n");
    client.print("Host: api.thingspeak.com\n");
    client.print("Connection: close\n");
    client.print("X-THINGSPEAKAPIKEY: " + apiKey + "\n");
    client.print("Content-Type: application/x-www-form-urlencoded\n");
    client.print("Content-Length: ");
    client.print(postStr.length());
    client.print("\n\n");
    client.print(postStr);

  }

  // Finalitzazció conexxió al servidor
  client.stop();

  // Deshabilitació pin Power On
  digitalWrite(pinON, LOW);
  delayMicroseconds(100);
}

